'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.newFunctionCall = newFunctionCall;

var _operations = require('./operations');

// Creates a function call, potentially rewriting it to another, more specific operation if applicable
function newFunctionCall(name, args) {
  switch (name) {
    case 'order':
      return newOrdering(args);
    default:
      return new _operations.FunctionCall(name, args);
  }
}

function newOrdering(args) {
  const terms = args.map(arg => {
    if (arg.op != 'sortDirection') {
      return new _operations.SortDirection({
        expression: arg,
        direction: 'asc'
      });
    }
    return arg;
  });
  return new _operations.Ordering(terms);
}
//# sourceMappingURL=functions.js.map